#ifndef TPU_ISRSOURCE_CXX
#define TPU_ISRSOURCE_CXX

//----------------------------------
// Includes and forward declarations
//----------------------------------
#include "cyg/hal/tpu_isrsource.h"

#if !defined(CYG_HAL_STARTUP_STUBS) && defined(CYG_HAL_MPC555)
#include "cyg/hal/imb3_isrdispatch.h"

//---------------------
// Class implementation
//---------------------
// Public constructor(s) and destructor
TPU_isrSource::TPU_isrSource(IMB3_isrDispatcher * a_dispatcher,
                             unsigned char a_isrpriority,
                             TPU_isrSource::TPU_IDENTIFICATION a_identification)
    : IMB3_isrSource(a_dispatcher),
      m_priority(a_isrpriority),
      m_identification(a_identification)
{
  a_dispatcher->attachToPriority(this, a_isrpriority);
}

// Provide an (empty) virtual destructor
TPU_isrSource::~TPU_isrSource()
{
}

//------------------------
// Public member functions
//------------------------
// findInterruptingVector
cyg_uint32 TPU_isrSource::findInterruptingVector(unsigned char a_priority)
{
  return 0;
}

// enableInterrupts
void TPU_isrSource::enableInterrupts(void)
{
}

// disableInterrupts
void TPU_isrSource::disableInterrupts(void)
{
}
#endif // if !defined ...

#endif // TPU_ISRSOURCE_CXX
