#ifndef KINTERRUPT_CXX
#define KINTERRUPT_CXX

//----------------------------------
// Includes and forward declarations
//----------------------------------
#include "cyg/kal/kinterrupt.h"

//---------------------
// Class implementation
//---------------------
// Constructor
KInterrupt::KInterrupt(KInterruptVector a_vector, KInterruptPriority a_priority)
    : m_vector(a_vector)
{
  cyg_interrupt_create(a_vector, 
                       a_priority, 
                       (cyg_addrword_t)this, 
                       (cyg_ISR_t *)s_isr, 
                       (cyg_DSR_t *)s_dsr, 
                       &m_handle, 
                       this);
  cyg_interrupt_attach(m_handle);
}

// Destructor
KInterrupt::~KInterrupt()
{
  cyg_interrupt_detach(m_handle);
  cyg_interrupt_delete(m_handle);
}

//------------------------
// Other protected members
//------------------------
// mask
void KInterrupt::mask(void)
{
  cyg_interrupt_mask(m_vector);
}

// unmask
void KInterrupt::unmask(void)
{
  cyg_interrupt_unmask(m_vector);
}

// acknowledge
void KInterrupt::acknowledge(void)
{
  cyg_interrupt_acknowledge(m_vector);
}

//---------------
// static members
//---------------
// s_isr
unsigned int KInterrupt::s_isr(KInterruptVector /*a_vector*/, void * a_data)
{
  return ((KInterrupt *)a_data)->isr();
}

// s_dsr
void KInterrupt::s_dsr(KInterruptVector /*a_vector*/, unsigned long a_count, void * a_data)
{
  ((KInterrupt *)a_data)->dsr(a_count);
}

#endif // KINTERRUPT_CXX
