#include <stdio.h>
#include <cyg/kal/kaldelay.h>
#include <cyg/kal/kalsync.h>
#include <cyg/kal/kalthread.h>

unsigned char stack1[2000];
unsigned char stack2[2000];

CCondition condition;

class TestThread : public CThread
{
  public:
                       TestThread(unsigned int a_priority, char * a_name, void * a_stack);
    virtual            ~TestThread();

  protected:
    virtual void       threadEntry(void);
    char               m_name[3];
};

TestThread::TestThread(unsigned int a_priority, char * a_name, void * a_stack)
    : CThread(a_priority, a_name, a_stack, 2000)
{
  strcpy(m_name, a_name);
}

TestThread::~TestThread()
{
}

void TestThread::threadEntry(void)
{
  CSingleLock sl(&condition);

  for(;;)
  {
    if(sl.lock(500))
      printf("%s released\n", m_name);
    else
      printf("%s timeout\n", m_name);
    sl.unlock();
  }
}

int main()
{
  TestThread t1(15, "t1", &stack1[0]);
  TestThread t2(15, "t2", &stack2[0]);

  t1.resume();
  t2.resume();

  for(;;)
  {
    CDelay(1000);
    condition.signal();
  }

  return 0;
}
